package cz.Plague.bukkit.PlgSetspawn;

import org.bukkit.ChatColor;
import org.bukkit.Location;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;
import org.bukkit.plugin.PluginDescriptionFile;
import org.bukkit.plugin.java.JavaPlugin;


/**
 * PlgSetspawn for Bukkit
 *
 * @author Plague
 */
public class PlgSetspawn extends JavaPlugin {

    public void onEnable() {
        PluginDescriptionFile pdfFile = this.getDescription();
        System.out.println(pdfFile.getName() + " version " + pdfFile.getVersion() + " is enabled!");
    }
    
    public void onDisable() {
    	PluginDescriptionFile pdfFile = this.getDescription();
        System.out.println(pdfFile.getName() + " version " + pdfFile.getVersion() + " stopping...");
    }
   
    public boolean onCommand(CommandSender sender, Command command, String commandLabel, String[] args) {
    	// both commands need a player to be the sender to get the location!
    	if (!(sender instanceof Player)) {
    		sender.sendMessage(ChatColor.RED + "This command has to be called by a player!");
    		return true;
    	}
    	Player player = (Player)sender;
    	// OP version
    	//if (!player.isOp()) return true;

    	if (command.getName().equalsIgnoreCase("plg_setspawn")) {
    		if (!player.isOp()) {
        		player.sendMessage(ChatColor.RED + "You have to be OP!");
        		return true;

        	}
    		Location spawn = player.getLocation();
    		player.getWorld().setSpawnLocation(spawn.getBlockX(), spawn.getBlockY(), spawn.getBlockZ());
			player.sendMessage(ChatColor.RED + "Spawn set");
    	} else if (command.getName().equalsIgnoreCase("plg_spawn")) {
    		// fix the position to the center of a block
    		Location spawn = player.getWorld().getSpawnLocation();
			spawn.setX(spawn.getBlockX() + 0.5);
			spawn.setY(spawn.getBlockY());
			spawn.setZ(spawn.getBlockZ() + 0.5);
			player.teleport(spawn);
    	} else
    		return false;  // unknown command, should not happen
    	return true;
    }
    
}
